var WiKID_token = new Object();

WiKID_token.chromeLoad = function() {
    //WiKID_token._trace("=> WiKID.chromeLoad");

    WiKID_token.initialize();

    WiKID_token._listener = WiKID_token.createProgressListener();
    WiKID_token._listener.onLocationChange = function (aProgress, aRequest, aStatus) {
        WiKID_token._instrumentBrowsers();
    }

    WiKID_token._tabBrowser.addProgressListener(WiKID_token._listener, Components.interfaces.nsIWebProgress.NOTIFY_LOCATION);
    WiKID_token._onPageLoad = function(aEvent) {
        WiKID_token._loadingInterceptor(WiKID_token._runDetector);
    };
    document.getElementById("appcontent").addEventListener("load", WiKID_token._onPageLoad, true);
    Components.classes["@mozilla.org/uriloader;1"]
        .getService(Components.interfaces.nsIURILoader)
            .registerContentListener(WiKID_token);
    //WiKID_token._trace("WiKID.chromeLoad =>");

}


WiKID_token.chromeUnload = function() {

    // remove the listeners to avoid leaking memory
    window.getBrowser().removeProgressListener(WiKID_token._listener);
    document.getElementById("appcontent").removeEventListener("load", WiKID_token._onPageLoad, true);

    // unregister as a URI content listener
    Components.classes["@mozilla.org/uriloader;1"]
        .getService(Components.interfaces.nsIURILoader)
            .unRegisterContentListener(WiKID_token);

    // cut the references to the objects we created
    WiKID_token._browsers = null;
    WiKID_token._browserToCollector = null;
    WiKID_token._browserToSourceName = null;
	WiKID_token._contentListener = null;
    WiKID_token._tabBrowser = null;
    WiKID_token._listener = null;

//    PB_Debug.trace("piggybank.js","< chromeUnload");
//    PB_Debug.trace("piggybank.js","----- [Disposed PiggyBank Overlay] -----");
}


WiKID_token._runDetector = function() {
    //WiKID_token._trace("=> WiKID_token._runDetector ");
    WiKID_token._getDetector(WiKID_token._tabBrowser.selectedBrowser).loadDataForCurrentDocument();
    //WiKID_token._trace("WiKID_token._runDetector =>");
}

WiKID_token._loadingInterceptor = function(continuation) {

        continuation();

}

WiKID_token._instrumentBrowsers = function() {
    //WiKID_token._trace("=> WiKID_token._instrumentBrowsers ");
    var browsers = WiKID_token._tabBrowser.browsers;
    for (var i = 0; i < WiKID_token._browsers.length; i++) {
        var browser = WiKID_token._browsers[i];
        var exists = false;

        for (var j = 0; j < browsers.length; j++) {
            if (browser == browsers[j]) {
                exists = true;
                break;
            }
        }

        if (!exists) {
            WiKID_token._browsers.splice(i,1);

            var sourceName = WiKID_token._browserToSourceName[browser];
            if (sourceName) {
                WiKID_token._browserToSourceName[browser] = null;
            }

            WiKID_token._removeDetector(browser).dispose();
        }
    }
    // Add a collector to any new browser
    for (var i = 0; i < browsers.length; i++) {
        var browser = browsers[i];
        var exists = false;

        for (var j = 0; j < WiKID_token._browsers.length; j++) {
            if (browser == WiKID_token._browsers[j]) {
                exists = true;
                break;
            }
        }
        if (!exists) {
            WiKID_token._browsers.splice(i,0,browser);
            WiKID_token._setDetector(browser, new WiKID_Detector(WiKID_token._tabBrowser, browser));
        }
    }
//    WiKID_token._getDetector(WiKID_token._tabBrowser.selectedBrowser).updateWindow();
    //WiKID_token._trace("WiKID_token._instrumentBrowsers =>");
}



WiKID_token._removeDetector = function(browser) {
    var detector = WiKID_token._browserToDetector[WiKID_token._getBrowserKey(browser)];
    WiKID_token._browserToDetector[WiKID_token._getBrowserKey(browser)] = null;
    return detector;
}

WiKID_token._setDetector = function(browser, detector) {
   WiKID_token._browserToDetector[WiKID_token._setBrowserKey(browser)] = detector;
}

WiKID_token._getDetector = function(browser) {
   var key = WiKID_token._getBrowserKey(browser);
    return WiKID_token._browserToDetector[key];
}


WiKID_token._getBrowserKey = function(browser) {
    return browser.getAttribute("WiKID-key");
}

WiKID_token._setBrowserKey = function(browser) {
    var key = (new Date()).getTime();
    browser.setAttribute("WiKID-key", key);
    return key;
}

WiKID_token.getTabBrowser = function() {
    return top.document.getElementById("content");
}

WiKID_token.createProgressListener = function ()
{
    return {
        onLocationChange : function(webProgress, request, location) {},
        onProgressChange : function(webProgress, request, curSelfProgress, maxSelfProgress, curTotalProgress, maxTotalProgress) {},
        onSecurityChange : function(webProgress, request, state) {},
        onStateChange : function(webProgress, request, stateFlags, status) {},
        onStatusChange : function(webProgress, request, status, message) {},
        QueryInterface : function(iid) {
            if (!iid.equals(Components.interfaces.nsIWebProgressListener) &&
                !iid.equals(Components.interfaces.nsISupportsWeakReference) &&
                !iid.equals(Components.interfaces.nsISupports)) {
                throw Components.results.NS_ERROR_NO_INTERFACE;
            }
            return this;
        }
    }
}



WiKID_token.initialize = function() {

//    WiKID_token._trace("=> WiKID_token.initialize");

    try {
        // obtain the required xpcom components
//        var log = Components.classes["@simile.mit.edu/logger;1"].getService(Components.interfaces.nsILogger)
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
//
//        // Prepare the browser and collector instrumentation caches --------------------
        WiKID_token._browsers = [];
        WiKID_token._browserToDetector = [];
        WiKID_token._browserToSourceName = [];
        WiKID_token._tabBrowser = WiKID_token.getTabBrowser();
    } catch (e) {
        this._fail(e);
    }

//    WiKID_token._trace("WiKID_token.initialize =>");

};


WiKID_token.loadToken = function() {

    WiKID_token._trace("=> WiKID_token.loadToken");

    try {
        /*
         *  Get a WiKIDToken component
         */
        var tkn = this.getJSToken();

        /*
         *  Initialize it. The trick is to get past its IDL interface
         *  and right into its Javascript implementation, so that we
         *  can pass it the LiveConnect "java" object, which it will
         *  then use to load its JARs. Note that XPCOM Javascript code
         *  is not given LiveConnect by default.
         */
        if (!tkn.wrappedJSObject.initialize(java, true)) {
            alert(WiKID_token.JAVA_TOKEN.wrappedJSObject.error);
        }
    } catch (e) {
        alert("Token creation failed:" + e );
        this._fail(e);
    }
    WiKID_token.JAVA_TOKEN = this.getToken;
    WiKID_token._trace("WiKID_token.loadToken =>");

};



WiKID_token.WiKID_getPasscode = function() {
    try {
        var pinFieldBox = document.getElementById("PIN-field-container");
        var passcodeFieldBox = document.getElementById("PassCode-field-container");
        var pinField = document.getElementById("PIN-field");
        var passcodeField = document.getElementById("PassCode-field");

        var pin = pinField.value;
        pinFieldBox.collapsed = true;
        pinField.value = "";
        var wikidToken = this.getToken();
        var detector = WiKID_token._getDetector(WiKID_token._tabBrowser.selectedBrowser);
        var wikidDom = wikidToken.getTokenConfig().getDomainByCode(detector._domain);
        var passcode =  wikidToken.getPasscode(wikidDom,pin);
        pinField.value = "";
        passcodeField.value = passcode;
        passcodeFieldBox.collapsed = false;
        passcodeField.select();
        passcodeField.readonly = "true";
        WiKID_token.putOnClipboard(passcode);
        openLoginWindow();
    } catch (e) {
        this._fail(e);
    }
};

WiKID_token.getToken = function() {
    var tokenReference = Components.classes["@wikidsystems.com/firefox-WikidToken;1"]
        .getService(Components.interfaces.nsIWiKIDToken);
    return tokenReference.wrappedJSObject.getWiKIDToken();
}

WiKID_token.getJSToken = function() {
    return Components.classes["@wikidsystems.com/firefox-WikidToken;1"]
        .getService(Components.interfaces.nsIWiKIDToken);
}

WiKID_token._trace = function (msg) {
    Components.classes["@mozilla.org/consoleservice;1"]
        .getService(Components.interfaces.nsIConsoleService)
            .logStringMessage(msg);
}

WiKID_token._fail = function(e) {
    var msg;
    if (e.getMessage) {
        msg = e + ": " + e.getMessage() + "\n";
        while (e.getCause() != null) {
            e = e.getCause();
            msg += "caused by " + e + ": " + e.getMessage() + "\n";
        }
    } else {
        msg = e;
    }
    alert(msg);
//}
};

// this should probably be somewhere else
WiKID_token._getProfilePath = function() {
    var fileLocator =
        Components.classes["@mozilla.org/file/directory_service;1"]
            .getService(Components.interfaces.nsIProperties);

    var path = escape(fileLocator.get("ProfD", Components.interfaces.nsIFile).path.replace(/\\/g, "/")) + "/";
    if (path.indexOf("/") == 0) {
        path = 'file://' + path;
    } else {
        path = 'file:///' + path;
    }

    return path;
};



function WiKID_toggleBar()
{
    var wikidToolbar = document.getElementById("WiKIDToolbar");
    var pinFieldBox = document.getElementById("PIN-field-container");
    var hiddenState = wikidToolbar.getAttribute("hidden");
    try{
        WiKID_token.removeListener();
    } catch (e) {

    }
    if(hiddenState != "false") {
        // if the JAVA_TOKEN doesn't exist load it.
        var reallyShowIt = false;
        if (!WiKID_token.JAVA_TOKEN ) {
            createJavaToken();
            reallyShowIt = false;
        }
        if (!WiKID_token.getToken().isOpen()) {
            if(tokenHasConfig()){
                openJavaToken();
            }  else {
                runConfigWizard();
            }
        }
        if (tokenHasThisDomain()){
            reallyShowIt = true;
        } else {
            registerToken();
//            if (tokenHasThisDomain()) {
//                reallyShowIt = true;
//            }
        }
        if (reallyShowIt){
            wikidToolbar.setAttribute("hidden", "false");
            resetPINField();
        }
    } else {
        WiKID_token.WiKID_closeBar();
    }
}

WiKID_token.WiKID_closeBar= function()
{
    var wikidToolbar = document.getElementById("WiKIDToolbar");
    var pinFieldBox = document.getElementById("PIN-field-container");
    var passcodeFieldBox = document.getElementById("PassCode-field-container");
    var passcodeField = document.getElementById("PIN-field");

    pinFieldBox.collapsed = false;
    resetPINField();
    passcodeField.value = "";
    passcodeFieldBox.collapsed = true;
    wikidToolbar.setAttribute("hidden", "true");
}

function openLoginWindow(passcode) {
    var detector = WiKID_token._getDetector(WiKID_token._tabBrowser.selectedBrowser);
    var browser;
    if(detector._login.indexOf("?newWindow=true") != -1){
        var loginWin = window.open("about:blank",
                "WiKID_LOGIN_PAGE",
                "height=300,width=400,status=yes,toolbar=no,location=no,directories=no,menubar=yes,copyhistory=no");
        loginWin.focus();
        var win =  loginWin.opener.wrappedJSObject;
//        alert(win.document.getElementById("content"));
        browser = loginWin.opener.wrappedJSObject.document.getElementById("content");
    } else {
        browser = WiKID_token._tabBrowser.selectedBrowser;
        //alert(browser);
    }
    browser.addProgressListener(pageDoneListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
    browser.loadURI(detector._login, browser.currentURI, browser.documentCharsetInfo.parentCharset );
}

WiKID_token.openRegistrarWindow = function () {
    var detector = WiKID_token._getDetector(WiKID_token._tabBrowser.selectedBrowser);
    var browser;
    if(detector._login.indexOf("?newWindow=true") != -1){
        var loginWin = window.open("about:blank",
                "WiKID_LOGIN_PAGE",
                "height=300,width=400,status=yes,toolbar=no,location=no,directories=no,menubar=yes,copyhistory=no");
        loginWin.focus();
        var win =  loginWin.opener.wrappedJSObject;
//        alert(win.document.getElementById("content"));
        browser = loginWin.opener.wrappedJSObject.document.getElementById("content");
    } else {
        browser = WiKID_token._tabBrowser.selectedBrowser;
        //alert(browser);
    }
    browser.addProgressListener(pageDoneListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
    browser.loadURI(detector._regPage, browser.currentURI, browser.documentCharsetInfo.parentCharset );
}

WiKID_token.removeListener = function() {
    WiKID_token._tabBrowser.selectedBrowser.removeProgressListener(pageDoneListener);
}

function resetPINField() {
    var pinField = document.getElementById("PIN-field");
    pinField.type=null;
    pinField.value="Enter PIN";
    pinField.select();
    pinField.focus();
}

function changePINField(){
    var pinField = document.getElementById("PIN-field");
    pinField.type="password";
}

function createJavaToken(){
    WiKID_token.loadToken();
}

function tokenHasConfig(){
    var wikidToken = WiKID_token.getToken();
    var profilePath = WiKID_token._getProfilePath();
    var hasCfg = wikidToken.hasConfig(profilePath+"/WiKIDToken.wkd");
    return hasCfg;
}

function openJavaToken(){
    //var tokenReference = WiKID_token.getToken();
    var wikidToken = WiKID_token.getToken();
    var profilePath = WiKID_token._getProfilePath();
    var hasCfg = wikidToken.hasConfig(profilePath+"/WiKIDToken.wkd");
    // Get the users passphrase
    window.openDialog("chrome://wikid/content/passphrase.xul","PassphraseDLG",
              "chrome,all,dialog=yes,modal,centerscreen",WiKID_token);
    // load the config using the passphrase
    try {
        wikidToken.load(profilePath+"WiKIDToken.wkd", WiKID_token.getPassphrase());
        var w = document.getElementById("WiKID-logo");
        w.src="chrome://wikid/skin/icons/w2.png";
    } catch (e){
        alert("Could not open token keystore!");
    }
    // wipe the passphrase
    WiKID_token.setPassphrase("");
}

function tokenHasThisDomain(){
    // check for domain in current configured doms
    var detector = WiKID_token._getDetector(WiKID_token._tabBrowser.selectedBrowser);
    var wikidToken = WiKID_token.getToken();
    var exists = wikidToken.getTokenConfig().getDomainByCode(detector._domain)
    return exists;
}

function registerToken(){
    // this token isn't registered in this servers's domain, register it!
    var detector = WiKID_token._getDetector(WiKID_token._tabBrowser.selectedBrowser);
    window.openDialog("chrome://wikid/content/RegistrationWizard.xul","regWiz",
              "chrome,all,dialog=yes,modal,centerscreen",WiKID_token,detector._domain);

}

function runConfigWizard(){
    // run the configuration wizard
    window.openDialog("chrome://wikid/content/configWizard.xul","configWiz",
              "chrome,all,dialog=yes,modal,centerscreen",WiKID_token);
}

function WiKID_ppAccept(baseWin) {
    var ppBox = document.getElementById("PWiKID_passpraseBox");
    baseWin.setPassphrase(ppBox.value);
}

function WiKID_ppCancel(baseWin) {
    baseWin.WiKID_closeBar();
    return true
}

WiKID_token.initTokenConfig = function(pp){
    // called from the setup wizard
    var wikidToken = WiKID_token.getToken();
    var profilePath = WiKID_token._getProfilePath();
    var _tokenConfig = wikidToken.load(profilePath+"WiKIDToken.wkd", pp);
    _tokenConfig.save(profilePath+"WiKIDToken.wkd", pp);
}

WiKID_token.getDomainInfo = function(code){
    // called from the setup wizard
    var wikidToken = WiKID_token.getToken();
    return wikidToken.getDomainConfig(code);
}

WiKID_token.setDomainPIN = function(domain,pin){
    // called from the setup wizard
    var wikidToken = WiKID_token.getToken();
    var regcode = wikidToken.setDomainPIN(domain,pin);
    WiKID_token.setRegcode(regcode);
    return regcode;
}

WiKID_token.keygenDone = function(){
    var wikidToken = WiKID_token.getToken();
    var profilePath = WiKID_token._getProfilePath();
    var hasCfg = wikidToken.hasConfig(profilePath+"/WiKIDToken.wkd");
    return hasCfg;
}

WiKID_token.setPassphrase = function(pp){
    this._passphrase = pp;
}

WiKID_token.getPassphrase = function(){
    return this._passphrase;
}

WiKID_token.setRegcode = function(rc){
    this._regcode = rc;
}

WiKID_token.getRegcode = function(){
    return this._regcode;
}

WiKID_token.putOnClipboard = function (text){
    const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
        .getService(Components.interfaces.nsIClipboardHelper);
      gClipboardHelper.copyString(text);
}


WiKID_token.enterInForm = function (){
    var passcodeField = document.getElementById("PassCode-field");
    var doc = WiKID_token._tabBrowser.selectedBrowser.contentDocument;
    var pcb = doc.getElementById("WiKID_Passcode");
    if (pcb) {
        this._trace("Found pcb:");
        pcb.value = passcodeField.value;
    }
    var rcb = doc.getElementById("WiKID_Regcode");
    if (rcb) {
        this._trace("Found rcb:");
        rcb.value = WiKID_token.getRegcode();
    }

}


WiKID_token.init = function() {
    this._trace("=> WiKID_token.init");
    window.addEventListener("load", WiKID_token.chromeLoad, false);
    window.addEventListener("unload", WiKID_token.chromeUnload, false);
    this._trace("WiKID_token.init =>");
}

var JAVA_TOKEN = null;






const STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START;
const STATE_STOP = Components.interfaces.nsIWebProgressListener.STATE_STOP;
var pageDoneListener =
{
  QueryInterface: function(aIID)
  {
   if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
       aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
       aIID.equals(Components.interfaces.nsISupports))
     return this;
   throw Components.results.NS_NOINTERFACE;
  },

  onStateChange: function(aProgress, aRequest, aFlag, aStatus)
  {
   if(aFlag & STATE_START)
   {
     // This fires when the load event is initiated
   }
   if(aFlag & STATE_STOP)
   {
    WiKID_token.enterInForm();
   }
   return 0;
  },

  onLocationChange: function(aProgress, aRequest, aURI)
  {
   // This fires when the location bar changes i.e load event is confirmed
   // or when the user switches tabs
   return 0;
  },

  // For definitions of the remaining functions see XulPlanet.com
  onProgressChange: function() {return 0;},
  onStatusChange: function() {return 0;},
  onSecurityChange: function() {return 0;},
  onLinkIconAvailable: function() {return 0;}
}



